import java.nio.file.*;
import java.util.*;

public class q7 {
    public static void main(String[] args) throws Exception {
        String myStr = args[0];
        String data = readFileAsString(myStr);  //reading file as string into data
        data = data.replace("\u2026", "");  //Removing horizontal ellipsis
        data = data.replace("\u002D", " ");  //Replacing - with " "
        data = data.replaceAll("\\p{Punct}", "");   //Removing Puctuations from the string
    
        List<String> wordsList = tokeningString(data);  //Creating Tokens
        List<String> stopWords = Arrays.asList("and", "the", "is", "in", "at", "of", "his", "her", "him");
        wordsList.removeAll(stopWords); //Removing the Stop Words from tokens

        //Creating TreeHashMap for lexicographical sorting
        Map<String, Integer> resultMap = new TreeMap<String, Integer>();
        for(String i : wordsList) {
            Integer j = resultMap.get(i);
            resultMap.put(i, (j == null) ? 1 : j+1);
        }
        
        //Sorting by frequency of values
        Map<String, Integer> finalList = sortByValue(resultMap);
        //Printing Output to screen
        for(Map.Entry<String, Integer> val : finalList.entrySet()) {
            System.out.println(val.getKey() + "," + val.getValue());
        }
    }
    
    //Method for Reading file as String
    public static String readFileAsString(String fileName) throws Exception {
        String data = "";
        data = new String(Files.readAllBytes(Paths.get(fileName)));
        return data;
    }

    //Method for tokening the String
    public static List<String> tokeningString(String datafile) {
        StringTokenizer st = new StringTokenizer(datafile);
        List<String> elements = new ArrayList<String>();
        while(st.hasMoreTokens()) {
            elements.add(st.nextToken());
        }
        return elements;
    }

    //Method for sorting by frequency of tokens
    public static HashMap<String, Integer> sortByValue(Map<String, Integer> resultMap) {
        //Creting new list for storing compared values
        List<Map.Entry<String, Integer>> afterCmpList = new LinkedList<Map.Entry<String, Integer>>(resultMap.entrySet());
        //Sorting the compared list
        Collections.sort(afterCmpList, new Comparator<Map.Entry<String, Integer>>() {
            public int compare(Map.Entry<String,Integer> obj1, Map.Entry<String, Integer> obj2) {
                return (obj2.getValue()).compareTo(obj1.getValue());
            }
        });
        //Moving data from sorted list to fianlList
        HashMap<String, Integer> temp = new LinkedHashMap<String, Integer>();
        for(Map.Entry<String, Integer> aa : afterCmpList) {
            temp.put(aa.getKey(), aa.getValue());
        }
        return temp;
     }
}
